scriptname GuardPlacementFuture extends ObjectReference
 
Quest property GuardPlacementQuest auto
 
ObjectReference r
ObjectReference property result hidden
	function set(ObjectReference akResult)
		done = true
		r = akResult
		;debug.trace("[Future] <<< " + self + " Got result " + r)
	endFunction
endProperty
 
bool done = false
bool function done()
	return done
endFunction
 
ObjectReference function get_result()
	;Terminate the request after 10 seconds, or as soon as we have a result
	int i = 0
	while !done && i < 100
		;debug.trace("[Future] @@@ " + self + " Waiting to finish...")
		i += 1
		utility.wait(0.1)
	endWhile
	RegisterForSingleUpdate(0.1)
 
        if i >= 100
            ;Our thread probably encountered an error and is locked up; we need to unlock it.
            (GuardPlacementQuest as GuardPlacementThreadManager).TryToUnlockThread(self as ObjectReference)
        endif
    ;debug.trace("[Future] >>> " + self + " Returning " + r)
	return r
endFunction
 
Event OnUpdate()
	self.Disable()
	self.Delete()
endEvent