scriptname SummonArmy extends ActiveMagicEffect
 
Quest property GuardPlacementQuest auto
{We need a reference to our quest with the threads and Thread Manager defined.}
ActorBase property Guard auto

ObjectReference Guard1
ObjectReference Guard2
ObjectReference Guard3
ObjectReference Guard4
ObjectReference Guard5
ObjectReference Guard6
ObjectReference Guard7
ObjectReference Guard8
ObjectReference Guard9
ObjectReference Guard10
ObjectReference Guard11
ObjectReference Guard12
ObjectReference Guard13
ObjectReference Guard14
ObjectReference Guard15
ObjectReference Guard16
ObjectReference Guard17
ObjectReference Guard18
ObjectReference Guard19
ObjectReference Guard20
 
Event OnEffectStart(Actor akTarget, Actor akCaster)
	if akCaster == Game.GetPlayer()
 		float start_time = Utility.GetCurrentRealTime()

		;Cast the Quest as our Thread Manager and store it
		GuardPlacementThreadManager threadmgr = GuardPlacementQuest as GuardPlacementThreadManager

		;For the purposes of this test, limit the number of available threads to 10 to exercise the Thread Manager's
		;ability to wait for and select available threads.
		threadmgr.thread_limit = 10

		;Call PlaceConjuredGuardAsync for each Guard and store the returned Future
		ObjectReference Guard1Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard2Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard3Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard4Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard5Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard6Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard7Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard8Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard9Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard10Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard11Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard12Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard13Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard14Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard15Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard16Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard17Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard18Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard19Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		ObjectReference Guard20Future = threadmgr.PlaceConjuredGuardAsync(Guard)
		threadmgr.wait_all()
 
		;Collect the results
		Guard1 = (Guard1Future as GuardPlacementFuture).get_result()
		Guard2 = (Guard2Future as GuardPlacementFuture).get_result()
		Guard3 = (Guard3Future as GuardPlacementFuture).get_result()
		Guard4 = (Guard4Future as GuardPlacementFuture).get_result()
		Guard5 = (Guard5Future as GuardPlacementFuture).get_result()
		Guard6 = (Guard6Future as GuardPlacementFuture).get_result()
		Guard7 = (Guard7Future as GuardPlacementFuture).get_result()
		Guard8 = (Guard8Future as GuardPlacementFuture).get_result()
		Guard9 = (Guard9Future as GuardPlacementFuture).get_result()
		Guard10 = (Guard10Future as GuardPlacementFuture).get_result()
		Guard11 = (Guard11Future as GuardPlacementFuture).get_result()
		Guard12 = (Guard12Future as GuardPlacementFuture).get_result()
		Guard13 = (Guard13Future as GuardPlacementFuture).get_result()
		Guard14 = (Guard14Future as GuardPlacementFuture).get_result()
		Guard15 = (Guard15Future as GuardPlacementFuture).get_result()
		Guard16 = (Guard16Future as GuardPlacementFuture).get_result()
		Guard17 = (Guard17Future as GuardPlacementFuture).get_result()
		Guard18 = (Guard18Future as GuardPlacementFuture).get_result()
		Guard19 = (Guard19Future as GuardPlacementFuture).get_result()
		Guard20 = (Guard20Future as GuardPlacementFuture).get_result()

		float end_time = Utility.GetCurrentRealTime()

		float time_delta = end_time - start_time
		debug.notification("Script completed in " + time_delta + " seconds.")
		debug.trace("[Future] (10 Threads) Script completed in " + time_delta + " seconds.")
	endif
endEvent
 
Event OnEffectFinish(Actor akTarget, Actor akCaster)
	if akCaster == Game.GetPlayer()
		DisableAndDelete(Guard1)
		DisableAndDelete(Guard2)
		DisableAndDelete(Guard3)
		DisableAndDelete(Guard4)
		DisableAndDelete(Guard5)
		DisableAndDelete(Guard6)
		DisableAndDelete(Guard7)
		DisableAndDelete(Guard8)
		DisableAndDelete(Guard9)
		DisableAndDelete(Guard10)
		DisableAndDelete(Guard11)
		DisableAndDelete(Guard12)
		DisableAndDelete(Guard13)
		DisableAndDelete(Guard14)
		DisableAndDelete(Guard15)
		DisableAndDelete(Guard16)
		DisableAndDelete(Guard17)
		DisableAndDelete(Guard18)
		DisableAndDelete(Guard19)
		DisableAndDelete(Guard20)
	endif
endEvent

function DisableAndDelete(ObjectReference akReference)
	akReference.Disable()
	akReference.Delete()
endFunction